mod program_test;
use {
    mpl_token_metadata::accounts::{MasterEdition, Metadata},
    program_test::StablebondProgramTest,
    solana_program_test::{tokio, ProgramTestContext},
    solana_sdk::{
        instruction::InstructionError,
        pubkey::Pubkey,
        signature::{Keypair, Signer},
        transaction::{Transaction, TransactionError},
    },
    spl_associated_token_account::{
        get_associated_token_address, get_associated_token_address_with_program_id,
    },
    stablebond_sdk::{
        errors::StablebondError,
        find_bond_pda, find_config_pda, find_delegate_pda, find_issuance_pda,
        find_payment_feed_pda, find_payment_pda, find_payout_pda,
        instructions::{
            CollectPayment, InitializeBond, InitializeBondInstructionArgs, InitializeConfig,
            InitializeConfigInstructionArgs, InitializeDelegate, InitializeIssuance,
            InitializeIssuanceInstructionArgs, InitializePaymentFeed,
            InitializePaymentFeedInstructionArgs, PurchaseBond, PurchaseBondInstructionArgs,
            StartIssuance,
        },
        types::{OracleSetup, PaymentFeedType},
    },
};

struct ExecuteTestContext {
    context: ProgramTestContext,
    admin: Keypair,
    user: Keypair,
    bond_mint: Keypair,
    usdc_mint: Pubkey,
    payment_base_price_feed_account: Pubkey,
    payment_quote_price_feed_account: Option<Pubkey>,
}

async fn setup() -> ExecuteTestContext {
    let pt = StablebondProgramTest::start_new().await;
    let usdc_mint = pt.mints[0].payment_mint;
    let bond_mint = pt.bond_mints[0].insecure_clone();
    let admin = pt.admin;
    let user = pt.users[0].insecure_clone();
    let payment_base_price_feed_account = pt.stub_payment_feed.base_price_feed;
    let payment_quote_price_feed_account = None;
    let nft_collection_mint = pt.nft_collection_mint;

    let initialize_config_ix_args = InitializeConfigInstructionArgs {
        oracle: OracleSetup::Stub,
        usdc_mxn_payment_feed: pt.usdc_mxn_payment_feed,
        usdc_usd_payment_feed: pt.usdc_usd_payment_feed,
    };

    let initialize_config_ix = InitializeConfig {
        admin_wallet: admin.pubkey(),
        config_account: find_config_pda().0,
        config_token_account: get_associated_token_address(
            &find_config_pda().0,
            &nft_collection_mint.pubkey(),
        ),
        mint_account: nft_collection_mint.pubkey(),
        metadata_account: Metadata::find_pda(&nft_collection_mint.pubkey()).0,
        master_edition_account: MasterEdition::find_pda(&nft_collection_mint.pubkey()).0,
        usdc_mxn_feed_account: find_payment_feed_pda(PaymentFeedType::UsdcMxn).0,
        usdc_usd_feed_account: find_payment_feed_pda(PaymentFeedType::UsdcUsd).0,
        token_program: spl_token::id(),
        associated_token_program: spl_associated_token_account::id(),
        metadata_program: mpl_token_metadata::ID,
        system_program: solana_program::system_program::id(),
    }
    .instruction(initialize_config_ix_args);

    let initialize_delegate_ix = InitializeDelegate {
        config_account: find_config_pda().0,
        admin_wallet: admin.pubkey(),
        delegate_wallet: admin.pubkey(),
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        system_program: solana_program::system_program::id(),
    }
    .instruction();

    let initialize_payment_feed_args = InitializePaymentFeedInstructionArgs {
        payment_feed_info: pt.stub_payment_feed,
    };

    let initialize_payment_feed_ix = InitializePaymentFeed {
        delegate_wallet: admin.pubkey(),
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        system_program: solana_program::system_program::id(),
    }
    .instruction(initialize_payment_feed_args);

    let initialize_bond_ix_args = InitializeBondInstructionArgs {
        decimals: 6,
        name: "Test Mint".to_string(),
        symbol: "TM".to_string(),
        uri: "https://test.com".to_string(),
        payment_feed_type: PaymentFeedType::Stub,
        cutoff_in_seconds: 60 * 60 * 24,
    };

    let initialize_bond_ix = InitializeBond {
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        delegate_wallet: admin.pubkey(),
        bond_account: find_bond_pda(bond_mint.pubkey()).0,
        mint_account: bond_mint.pubkey(),
        metadata_account: Metadata::find_pda(&bond_mint.pubkey()).0,
        token2022_program: spl_token_2022::id(),
        metadata_program: mpl_token_metadata::ID,
        sysvar_instructions: solana_program::sysvar::instructions::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction(initialize_bond_ix_args);

    let current_time = StablebondProgramTest::get_current_time();
    let one_minute_ago: i64 = current_time - 60;
    let one_week_from_now: i64 = 60 * 60 * 24 * 7;

    let initialize_issuance_ix_args = InitializeIssuanceInstructionArgs {
        liquidity: 100_000_000,
        interest_rate_bps: 11_00,
        estimated_start_datetime: one_minute_ago,
        length_in_seconds: one_week_from_now,
    };

    let issuance_number = 1;
    let bond_pda = find_bond_pda(bond_mint.pubkey()).0;
    let issuance_pda = find_issuance_pda(bond_pda, issuance_number).0;
    let payment_pda = find_payment_pda(issuance_pda).0;
    let payout_pda = find_payout_pda(issuance_pda).0;
    let initialize_issuance_ix = InitializeIssuance {
        delegate_wallet: admin.pubkey(),
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        bond_account: find_bond_pda(bond_mint.pubkey()).0,
        issuance_account: issuance_pda,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_mint_account: usdc_mint,
        payment_account: payment_pda,
        payment_token_account: get_associated_token_address(&payment_pda, &usdc_mint),
        payout_account: payout_pda,
        payout_token_account: get_associated_token_address(&payout_pda, &usdc_mint),
        associated_token_program: spl_associated_token_account::id(),
        token_program: spl_token::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction(initialize_issuance_ix_args);

    let start_issuance_ix = StartIssuance {
        delegate_account: find_delegate_pda(admin.pubkey()).0,
        delegate_wallet: admin.pubkey(),
        bond_account: find_bond_pda(bond_mint.pubkey()).0,
        issuance_account: find_issuance_pda(find_bond_pda(bond_mint.pubkey()).0, 1).0,
        mint_account: bond_mint.pubkey(),
        token2022_program: spl_token_2022::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction();

    let ixs = &[
        initialize_config_ix,
        initialize_delegate_ix,
        initialize_payment_feed_ix,
        initialize_bond_ix,
        initialize_issuance_ix,
        start_issuance_ix,
    ];

    let mut context = pt.context;
    let transaction = Transaction::new_signed_with_payer(
        ixs,
        Some(&admin.pubkey()),
        &[&admin, &nft_collection_mint, &bond_mint],
        context.last_blockhash,
    );

    context
        .banks_client
        .process_transaction(transaction)
        .await
        .unwrap();
    ExecuteTestContext {
        context,
        user,
        admin,
        bond_mint,
        usdc_mint,
        payment_base_price_feed_account,
        payment_quote_price_feed_account,
    }
}

#[tokio::test]
async fn collect_payment() {
    let mut et = setup().await;

    let recent_blockhash = et.context.last_blockhash;

    let purchase_bond_ix_args = PurchaseBondInstructionArgs { amount: 1_000_000 };
    let bond_account = find_bond_pda(et.bond_mint.pubkey()).0;
    let issuance_account = find_issuance_pda(bond_account, 1).0;
    let payment_account = find_payment_pda(issuance_account).0;
    let payment_token_account = get_associated_token_address(&payment_account, &et.usdc_mint);
    let user_token_account = get_associated_token_address_with_program_id(
        &et.user.pubkey(),
        &et.bond_mint.pubkey(),
        &spl_token_2022::id(),
    );
    let user_payment_token_account = get_associated_token_address(&et.user.pubkey(), &et.usdc_mint);

    let purchase_bond_ix = PurchaseBond {
        user_wallet: et.user.pubkey(),
        user_token_account,
        user_payment_token_account,
        config_account: find_config_pda().0,
        bond_account,
        issuance_account,
        payment_account,
        payment_token_account,
        mint_account: et.bond_mint.pubkey(),
        payment_mint_account: et.usdc_mint,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_base_price_feed_account: et.payment_base_price_feed_account,
        payment_quote_price_feed_account: et.payment_quote_price_feed_account,
        associated_token_program: spl_associated_token_account::id(),
        token_program: spl_token::id(),
        token2022_program: spl_token_2022::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction(purchase_bond_ix_args);

    let transaction = Transaction::new_signed_with_payer(
        &[purchase_bond_ix],
        Some(&et.user.pubkey()),
        &[&et.user],
        recent_blockhash,
    );

    assert!(et
        .context
        .banks_client
        .process_transaction(transaction)
        .await
        .is_ok());

    let delegate_wallet_token_account =
        get_associated_token_address(&et.admin.pubkey(), &et.usdc_mint);

    let collect_payment_ix = CollectPayment {
        delegate_wallet: et.admin.pubkey(),
        delegate_account: find_delegate_pda(et.admin.pubkey()).0,
        delegate_wallet_token_account,
        bond_account,
        issuance_account,
        payment_account,
        payment_token_account,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_mint_account: et.usdc_mint,
        token_program: spl_token::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction();

    let transaction = Transaction::new_signed_with_payer(
        &[collect_payment_ix],
        Some(&et.admin.pubkey()),
        &[&et.admin],
        recent_blockhash,
    );

    assert!(et
        .context
        .banks_client
        .process_transaction(transaction)
        .await
        .is_ok());
}

#[tokio::test]
async fn fail_collect_payment_invalid_delegate() {
    let mut et = setup().await;

    let recent_blockhash = et.context.last_blockhash;

    let purchase_bond_ix_args = PurchaseBondInstructionArgs { amount: 1_000_000 };
    let bond_account = find_bond_pda(et.bond_mint.pubkey()).0;
    let issuance_account = find_issuance_pda(bond_account, 1).0;
    let payment_account = find_payment_pda(issuance_account).0;
    let payment_token_account = get_associated_token_address(&payment_account, &et.usdc_mint);
    let user_token_account = get_associated_token_address_with_program_id(
        &et.user.pubkey(),
        &et.bond_mint.pubkey(),
        &spl_token_2022::id(),
    );
    let user_payment_token_account = get_associated_token_address(&et.user.pubkey(), &et.usdc_mint);

    let purchase_bond_ix = PurchaseBond {
        user_wallet: et.user.pubkey(),
        user_token_account,
        user_payment_token_account,
        config_account: find_config_pda().0,
        bond_account,
        issuance_account,
        payment_account,
        payment_token_account,
        mint_account: et.bond_mint.pubkey(),
        payment_mint_account: et.usdc_mint,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_base_price_feed_account: et.payment_base_price_feed_account,
        payment_quote_price_feed_account: et.payment_quote_price_feed_account,
        associated_token_program: spl_associated_token_account::id(),
        token_program: spl_token::id(),
        token2022_program: spl_token_2022::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction(purchase_bond_ix_args);

    let transaction = Transaction::new_signed_with_payer(
        &[purchase_bond_ix],
        Some(&et.user.pubkey()),
        &[&et.user],
        recent_blockhash,
    );

    assert!(et
        .context
        .banks_client
        .process_transaction(transaction)
        .await
        .is_ok());

    let delegate_wallet_token_account =
        get_associated_token_address(&et.admin.pubkey(), &et.usdc_mint);

    let collect_payment_ix = CollectPayment {
        delegate_wallet: et.user.pubkey(),
        delegate_account: find_delegate_pda(et.admin.pubkey()).0,
        delegate_wallet_token_account,
        bond_account,
        issuance_account,
        payment_account,
        payment_token_account,
        payment_feed_account: find_payment_feed_pda(PaymentFeedType::Stub).0,
        payment_mint_account: et.usdc_mint,
        token_program: spl_token::id(),
        system_program: solana_program::system_program::id(),
    }
    .instruction();

    let transaction = Transaction::new_signed_with_payer(
        &[collect_payment_ix],
        Some(&et.user.pubkey()),
        &[&et.user],
        recent_blockhash,
    );

    let error = et
        .context
        .banks_client
        .process_transaction(transaction)
        .await
        .err()
        .unwrap()
        .unwrap();

    match error {
        TransactionError::InstructionError(_, InstructionError::Custom(error_index)) => {
            let program_error = StablebondError::InvalidDelegateAddress as u32;
            assert_eq!(error_index, program_error + 6000);
        }
        _ => {
            panic!("Wrong error occurs while testing collect payment");
        }
    }
}
